<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\front\chartController;
use App\Http\Controllers\front\HomeController;
use App\Http\Controllers\front\customer\CustomerController;

use App\Http\Controllers\admin\DashboardController;
use App\Http\Controllers\admin\IndicatorController;


/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::get('/',[chartController::class,'index'])->name('/');
Route::get('real-gross-domestic-product',[chartController::class,'GDP'])->name('gdp');
Route::get('treasury-yield-spread',[chartController::class,'treasuryYieldSpread'])->name('tys');
Route::get('purchasing-manager-index',[chartController::class,'PMI'])->name('pmi');
Route::get('consumer-confidence-index',[chartController::class,'sp500'])->name('sp500');
Route::get('composite-leading-indicator',[chartController::class,'CLI'])->name('cli');
Route::get('us-employment-situation',[chartController::class,'USES'])->name('uses');
Route::get('us-jobless-claims',[chartController::class,'UJC'])->name('ujc');
Route::get('consumer-price-index',[chartController::class,'CPI'])->name('cpi');
Route::get('producer-price-index',[chartController::class,'PPI'])->name('ppi');
Route::get('unemployment',[chartController::class,'unemployment'])->name('unp');
Route::get('retail-sales',[chartController::class,'RS'])->name('rs');

Route::any('get-compiled-data', [ChartController::class, 'getIndexChartData']);


Route::get('/get-pmi-data1', [chartController::class, 'getPMIData1']);

//sectors
Route::get('/sec1',[chartController::class,'sec1'])->name('sec1');
Route::get('/sec2',[chartController::class,'sec2'])->name('sec2');
Route::get('/sec3',[chartController::class,'sec3'])->name('sec3');
Route::get('/sec4',[chartController::class,'sec4'])->name('sec4');
Route::get('/sec5',[chartController::class,'sec5'])->name('sec5');
Route::get('/sec6',[chartController::class,'sec6'])->name('sec6');

Route::get('/sec11',[chartController::class,'sec11'])->name('sec11');
Route::get('/sec22',[chartController::class,'sec22'])->name('sec22');
Route::get('/sec33',[chartController::class,'sec33'])->name('sec33');
Route::get('/sec44',[chartController::class,'sec44'])->name('sec44');
Route::get('/sec55',[chartController::class,'sec55'])->name('sec55');
Route::get('/sec66',[chartController::class,'sec66'])->name('sec66');


Route::get('/get-filtered-gdp-data', [chartController::class, 'getFilteredGdpData']);
Route::get('/get-filtered-tys-data', [chartController::class, 'getFilteredtysData']);
Route::get('/get-pmi-data', [chartController::class, 'getPMIData']);
Route::get('/get-sp500-data', [chartController::class, 'getsp500Data']);
Route::get('/get-cli-data', [chartController::class, 'getCLIData']);
Route::get('/get-cpi-data', [chartController::class, 'getCPIData']);
Route::get('/get-ppi-data', [chartController::class, 'getPPIData']);
Route::get('/get-rs-data', [chartController::class, 'getRSData']);
Route::get('/get-uses-data', [chartController::class, 'getUSESData']);
Route::get('/get-ujc-data', [chartController::class, 'getUJCData']);
Route::get('/get-unemployment-data', [chartController::class, 'getUnemploymentData']);

Route::get('/featured',[HomeController::class,'featured'])->name('featured');
Route::get('/benefits',[HomeController::class,'benefits'])->name('benefits');

Route::get('/faq',[HomeController::class,'faq'])->name('faq');

Route::get('/login',[CustomerController::class,'index'])->name('login');
Route::get('/register',[CustomerController::class,'register'])->name('register');

Route::get('/terms-of-services',[HomeController::class,'termServive'])->name('terms-of-services');
Route::get('/privacy-policy',[HomeController::class,'privacyPolicy'])->name('privacy-policy');

Route::group(['prefix'=>'admin'], function(){
    Route::get('/', [DashboardController::class,'dashboard'])->name('index');
    Route::get('/indicators', [IndicatorController::class,'index'])->name('indicators.index');
});

