
<?php $__env->startSection('content'); ?>

<main>
    <section class="indi-banner">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <h1 class="indi-ban-head">Real Gross Domestic Product (GDP)</h1>
                </div>
                <div class="col-12">
                    <p class="indi-ban-para">Overall measure of economic performance.</p>
                </div>
            </div>
        </div>
    </section>

    <section class="indicators">
        <div class="container">
            <div class="row gy-4">
                <div class="col-12 col-lg-6">
                    <h4>Real Gross Domestic Product (GDP)</h4>
                </div>
                <div class="col-12 col-lg-6">
                    <div class="text-end">
                        <a href="#">View Indicator Description</a>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <section class="indi-form">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <form action="">
                        <div class="row gy-4">
                            <div class="col-12 col-lg-4">
                                <div class="diff-form">
                                    <label for="country">Country</label>
                                    <select name="country" id="country" class="country">
                                        <!-- <option value="china">China</option> -->
                                        <option value="united States (US)">United States (US)</option>
                                        <!-- <option value="australia">Australia</option>
                                        <option value="argentina">Argentina</option>
                                        <option value="canada">Canada</option> -->
                                    </select>
                                </div>
                            </div>
                            <div class="col-12 col-lg-4">
                                <div class="diff-form">
                                    <label for="component">Component</label>
                                    <select name="component" id="component" class="component">
                                        <option value="total">Total</option>
                                        <option value="total">Total</option>
                                        <option value="total">Total</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-12 col-lg-4">
                                <div class="diff-form">
                                    <label for="measure">Measure</label>
                                    <select name="measure" id="measure" class="measure">
                                        <option value="value">Value</option>
                                        <option value="value 1">Value 1</option>
                                        <option value="value 2">Value 2</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-12 col-lg-4">
                                <div class="form-radio text-center">
                                    <input type="radio" name="years" class="year-checkbox" value="300" checked>
                                    <label for="all">ALL</label>
                                    <input type="radio" name="years" class="year-checkbox"  value="25">
                                    <label for="25y">25Y</label>
                                    <input type="radio" name="years" class="year-checkbox"  value="10">
                                    <label for="10y">10Y</label>
                                    <input type="radio" name="years" class="year-checkbox"  value="5">
                                    <label for="5y">5Y</label>
                                    <input type="radio" name="years" class="year-checkbox" value="3">
                                    <label for="3y">3Y</label>
                                    <input type="radio" name="years" class="year-checkbox" value="1">
                                    <label for="1y">1Y</label>
                                </div>
                            </div>
                            <div class="col-12 col-lg-4">
                                <div class="text-center">
                                    <label for="average">Moving Average:</label>
                                    <select name="average" id="average" class="average">
                                        <option value="average">off</option>
                                        <option value="average">on</option>
                                    </select>
                                </div>
                            </div>
                            <!-- <button id="downloadCSV">Download CSV</button> -->
                            <div class="col-12 col-lg-4">
                                <div class="text-center">
                                      <button id="downloadCSV">Download CSV</button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </section>


    <section class="indi-graph">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <!-- <img src="images/indigraph.png" alt=""> -->
                    <!-- <div id="chartContainer1" style="height: 600px; width: 100%;"></div> -->
                    <canvas id="gdpChart" width="800" height="400"></canvas>

                </div>
            </div>
        </div>
    </section>


    <section class="faq-links">
        <div class="container">
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <p>Sources: <a href="#"> Organisation for Economic Co-operation and Development (OECD);</a> <a
                                href="#"> U.S.
                                Bureau of Economic Analysis</a></p>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <section class="indi-f-aq">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <div class="accordion" id="accordionExample">
                        <div class="accordion-item">
                            <h2 class="accordion-header" id="headingOne">
                                <button class="accordion-button" type="button" data-bs-toggle="collapse"
                                    data-bs-target="#collapseOne" aria-expanded="true" aria-controls="collapseOne">
                                    Additional Indicator Details
                                </button>
                            </h2>
                            <div id="collapseOne" class="accordion-collapse collapse show" aria-labelledby="headingOne"
                                data-bs-parent="#accordionExample">
                                <div class="accordion-body">
                                    <p>Unit: National currency</p>
                                    <p>Multiplier: Millions</p>
                                    <p>Adjustment: Seasonally adjusted; United States seasonally adjusted annual rate
                                    </p>
                                    <p>Note: The base year used to calculate real GDP varies by country.</p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
    <section class="indi-content">
        <div class="container">
            <div class="row">
                <div class="col-12">
                    <h3 class="main-indi-head pad-acc">What is Real Gross Domestic Product (GDP)?</h3>
                </div>
                <div class="col-12">
                    <p class="main-indi-content">Real Gross Domestic Product (GDP) is a comprehensive measure of a
                        country’s economic performance. It represents the total value of all goods and services produced
                        over a specific time period, adjusted for inflation. As a critical indicator, Real GDP offers a
                        clear view of the economic health of a nation, making it an essential metric for investors and
                        analysts.</p>
                </div>
                <div class="col-12">
                    <h3 class="main-indi-head">Methodology</h3>
                </div>
                <div class="col-12">
                    <p class="main-indi-content">The calculation of Real GDP adjusts the nominal GDP figure to account
                        for inflation, using a price deflator. This method distinguishes real growth from
                        inflation-induced growth, offering a clearer picture of an economy’s true performance. While the
                        basic framework for calculating Real GDP is globally recognized, there can be variations in the
                        specific methodologies employed by different countries. These variations might include
                        differences in the choice of deflator or in the treatment of certain economic activities.
                        Despite these differences, Real GDP remains one of the more reliable methods for evaluating and
                        comparing the economic performance of countries, offering a standardized, albeit not perfectly
                        uniform, basis for analysis.</p>
                </div>
                <div class="col-12">
                    <h3 class="main-indi-head">Global Relevance</h3>
                </div>
                <div class="col-12">
                    <p class="main-indi-content">Real GDP holds immense global relevance as it provides a standardized
                        measure for comparing the economic performance of different countries. This uniformity is
                        crucial for investors and policymakers who rely on Real GDP to make informed decisions. It
                        reflects the economic activity and health of a nation, influencing global investment flows and
                        economic policies.</p>
                </div>
                <div class="col-12">
                    <h3 class="main-indi-head">Interpretation</h3>
                </div>
                <div class="col-12">
                    <p class="main-indi-content">As a lagging indicator, Real GDP is vital for verifying the trends
                        predicted by leading indicators. It doesn’t serve to predict future economic directions but
                        rather confirms whether the economic outcomes forecasted by other indicators have materialized.
                        Understanding Real GDP helps in assessing the effectiveness of economic policies and the overall
                        health of an economy, making it a key tool for strategic decision-making in the financial
                        markets.</p>
                </div>
            </div>
        </div>
    </section>
</main>


<?php $__env->startSection('script'); ?>

<!-- Include jQuery library -->
<script src="https://code.jquery.com/jquery-3.6.4.min.js"></script>

<!-- Include Moment.js library -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.1/moment.min.js"></script>

<!-- Include Chart.js library -->
<script src="https://cdn.jsdelivr.net/npm/chart.js"></script>

<!-- Include Chart.js adapter for Moment.js -->
<script src="https://unpkg.com/chartjs-adapter-moment@latest/dist/chartjs-adapter-moment.min.js"></script>

<script>
    $(document).ready(function () {
        // Call the main function after the document is ready
        initializeChart();

        function initializeChart() {
            var ctx = document.getElementById('gdpChart').getContext('2d');
            var gdpChart;

            function updateChart(filterVariable) {
                console.log('Updating chart with filter variable:', filterVariable);
                $.ajax({
                    url: "<?php echo e(url('/get-filtered-gdp-data')); ?>",
                    type: 'GET',
                    data: {
                        filter_variable: filterVariable,
                    },
                    success: function (response) {
                        console.log('Received response:', response);
                        var dates = response.observations.map(observation => observation.date);
                        var values = response.observations.map(observation => observation.value);

                        console.log('Dates:', dates);
                        console.log('Values:', values);

                        if (gdpChart) {
                            gdpChart.destroy();
                        }

                        gdpChart = new Chart(ctx, {
                            type: 'line',
                            data: {
                                labels:dates,
                                datasets: [{
                                    label: 'Real GDP',
                                    data: values,
                                    borderColor: 'rgba(75, 192, 192, 1)',
                                    borderWidth:1,
                                    fill: false,
                                }],
                            },
                            options: {
                                scales: {
                                    x: {
                                        type: 'time',
                                        time: {
                                            unit: 'year',
                                            displayFormats: {
                                                year: 'YYYY-MM-DD',
                                            },
                                        },
                                        position:'bottom',
                                    },
                                    y: {
                                        min: 1000,
                                    },
                                },
                            },
                        });
                    },
                    error: function (error) {
                        console.log('Error fetching GDP data:', error);
                    }
                });
            }

            var yearCheckboxInputs = $('.year-checkbox');
            var updateButton = $('#updateButton');
            var downloadCSVButton = $('#downloadCSV');
            yearCheckboxInputs.on('change', function () {
                var filterVariable = $('input[name="years"]:checked').val();
                updateChart(filterVariable);
            });

            downloadCSVButton.on('click', function () {
                downloadCSV();
            });

            // Initial chart load
            updateChart($('input[name="years"]:checked').val());

            function downloadCSV() {
                var data = gdpChart.data;
                var csvContent = "Date,Value\n";

                for (var i = 0; i < data.labels.length; i++) {
                    csvContent += data.labels[i] + "," + data.datasets[0].data[i] + "\n";
                }

                var blob = new Blob([csvContent], { type: 'text/csv;charset=utf-8;' });
                var link = document.createElement('a');

                if (navigator.msSaveBlob) { // IE 10+
                    navigator.msSaveBlob(blob, 'GDP.csv');
                } else {
                    link.href = URL.createObjectURL(blob);
                    link.download = 'GDP.csv';
                    link.style.visibility = 'hidden';
                    document.body.appendChild(link);
                    link.click();
                    document.body.removeChild(link);
                }
            }
        }
    });
</script>

<?php $__env->stopSection(); ?>
<?php $__env->stopSection(); ?>
<?php echo $__env->make('front.layout.app', \Illuminate\Support\Arr::except(get_defined_vars(), ['__data', '__path']))->render(); ?><?php /**PATH /home/custom/public_html/reyan/resources/views/front/gdp.blade.php ENDPATH**/ ?>